-- Biodiversity by
-- dave@beermex.com

require( 'flowers' )
require( 'bees' )
--require( 'genes' )

function Tutorial1Setup()
	bees = { {} }

	colorgene = Gene:new('Color',{1,1,1}, 'count', {3,0,0} )
	heightgene = Gene:new('Height', {1}, 'value', {3} )
	poisongene = Gene:new('Poison',{1}, 'count', {0})
	numpetals = Gene:new('NumPetals',{3}, 'value', {0} )
	attractiveness = Gene:new('Attractiveness', {1}, 'count', {0} )

	genes = { colorgene=colorgene, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	flowers = {}
	MUTATION_ENABLED=false

	addflower( 2, 4, nil, nil, nil, nil, genes )
	addflower( 4, 1, nil, nil, nil, nil, genes )
	addflower( 5, 4, nil, nil, nil, nil, genes )
	for i=1,#flowers do
		flowers[i].state = 'living'
	end
end

function Tutorial1Goal()
	local success = false
	if #flowers > 3 then
		for i=1,#flowers do
			flowers[i].g_match=true
		end
		flowers_winning_dude()
		success = true
	end
	return success
end

function Tutorial2Setup()
	bees = { {} }

	colorgene = Gene:new('Color',{1,1,1}, 'count', {3,0,0} )
	heightgene = Gene:new('Height', {1}, 'value', {3} )
	poisongene = Gene:new('Poison',{1}, 'count', {3})
	numpetals = Gene:new('NumPetals',{3}, 'value', {3} )
	attractiveness = Gene:new('Attractiveness', {1}, 'count', {0} )

	genes = { colorgene=colorgene, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	flowers = {}
	MUTATION_ENABLED=false

	addflower( 3, 2, nil, nil, nil, nil, genes )
end

function Tutorial2Goal()
	local success = false
	if #flowers > 1 then
		for i=1,#flowers do
			flowers[i].g_match=true
		end
		flowers_winning_dude()
		success = true
	end
	return success
end

function Tutorial3Setup()
	bees = { {} }

	flowers = {}
	MUTATION_ENABLED=false

	colorgene = Gene:new('Color',{1,1,1}, 'count', {1,3,3} )
	heightgene = Gene:new('Height', {1}, 'value', {3} )
	poisongene = Gene:new('Poison',{1}, 'count', {3})
	numpetals = Gene:new('NumPetals',{3}, 'value', {12} )
	attractiveness = Gene:new('Attractiveness', {1}, 'count', {0} )
	genes = { colorgene=colorgene, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	colorgene2 = Gene:new('Color',{1,1,1}, 'count', {3,2,3} )
	genes2 = { colorgene=colorgene2, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	colorgene3 = Gene:new('Color',{1,1,1}, 'count', {3,3,1} )
	genes3 = { colorgene=colorgene3, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	colorgene4 = Gene:new('Color',{1,1,1}, 'count', {3,3,3} )
	genes4 = { colorgene=colorgene4, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	addflower( 1, 1, nil, nil, nil, nil, genes )
	addflower( 6, 1, nil, nil, nil, nil, genes2 )
	addflower( 1, 6, nil, nil, nil, nil, genes3 )
	addflower( 6, 6, nil, nil, nil, nil, genes4 )
end

function Tutorial3Goal()
	local success = false
	for i=1,#flowers do
		flowers[i].g_match=nil
		if flowers[i].state ~= 'dead' and flowers[i].state ~= 'fruit' and flowers[i].state ~= 'growing' and flowers[i].state ~= 'dying' then
			local c = flowers[i].genes.colorgene:getValueAsAlleleValues()
			if c[1].value ~= 1 or c[2].value ~= 1 or c[3].value ~= 1 then
				flowers[i].g_match=true
				success = true
			end
		end
	end

	if success then
		flowers_winning_dude()
	end

	return success
end


function Tutorial4Setup()
	bees = { {} }

	flowers = {}
	MUTATION_ENABLED=false

	colorgene = Gene:new('Color',{1,1,1}, 'count', {0,3,3} )
	heightgene = Gene:new('Height', {1}, 'value', {2} )
	poisongene = Gene:new('Poison',{1}, 'count', {0})
	numpetals = Gene:new('NumPetals',{3}, 'value', {3} )
	attractiveness = Gene:new('Attractiveness', {1}, 'count', {0} )
	genes = { colorgene=colorgene, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	colorgene2 = Gene:new('Color',{1,1,1}, 'count', {1,1,0} )
	heightgene2 = Gene:new('Height', {1}, 'value', {3} )
	numpetals2 = Gene:new('NumPetals',{3}, 'value', {12} )
	genes2 = { colorgene=colorgene2, heightgene=heightgene2, poisongene=poisongene, numpetals=numpetals2, attractiveness=attractiveness }

	colorgene3 = Gene:new('Color',{1,1,1}, 'count', {0,3,0} )
	heightgene3 = Gene:new('Height', {1}, 'value', {3} )
	numpetals3 = Gene:new('NumPetals',{3}, 'value', {10} )
	genes3 = { colorgene=colorgene3, heightgene=heightgene3, poisongene=poisongene, numpetals=numpetals3, attractiveness=attractiveness }

	colorgene4 = Gene:new('Color',{1,1,1}, 'count', {2,0,2} )
	heightgene4 = Gene:new('Height', {1}, 'value', {1} )
	numpetals4 = Gene:new('NumPetals',{3}, 'value', {5} )
	genes4 = { colorgene=colorgene4, heightgene=heightgene4, poisongene=poisongene, numpetals=numpetals4, attractiveness=attractiveness }

	addflower( 4, 6, nil, nil, nil, nil, genes )
	addflower( 6, 4, nil, nil, nil, nil, genes2 )
	addflower( 4, 2, nil, nil, nil, nil, genes3 )
	addflower( 2, 4, nil, nil, nil, nil, genes4 )
end

function Tutorial4Goal()
	local success = false
	for i=1,#flowers do
		flowers[i].g_match=nil
		if flowers[i].state ~= 'dead' and flowers[i].state ~= 'fruit' and flowers[i].state ~= 'growing' and flowers[i].state ~= 'dying' then
			local h = flowers[i].genes.heightgene:getValueAsAlleleValues()
			if h[1].value == 0 then
				flowers[i].g_match=true
				success = true
			end
		end
	end

	if success then
		flowers_winning_dude()
	end

	return success
end


function Tutorial5Setup()
	bees = { {} }

	flowers = {}
	MUTATION_ENABLED=false

	colorgene = Gene:new('Color',{1,1,1}, 'count', {2,0,0} )
	heightgene = Gene:new('Height', {1}, 'value', {2} )
	poisongene = Gene:new('Poison',{1}, 'count', {0})
	numpetals = Gene:new('NumPetals',{3}, 'value', {3} )
	attractiveness = Gene:new('Attractiveness', {1}, 'count', {0} )
	genes = { colorgene=colorgene, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	colorgene2 = Gene:new('Color',{1,1,1}, 'count', {0,0,0} )
	heightgene2 = Gene:new('Height', {1}, 'value', {3} )
	numpetals2 = Gene:new('NumPetals',{3}, 'value', {12} )
	genes2 = { colorgene=colorgene2, heightgene=heightgene2, poisongene=poisongene, numpetals=numpetals2, attractiveness=attractiveness }

	colorgene3 = Gene:new('Color',{1,1,1}, 'count', {1,3,2} )
	heightgene3 = Gene:new('Height', {1}, 'value', {3} )
	numpetals3 = Gene:new('NumPetals',{3}, 'value', {48} )
	genes3 = { colorgene=colorgene3, heightgene=heightgene3, poisongene=poisongene, numpetals=numpetals3, attractiveness=attractiveness }

	addflower( 3, 2, nil, nil, nil, nil, genes )
	addflower( 4, 2, nil, nil, nil, nil, genes2 )
	addflower( 5, 2, nil, nil, nil, nil, genes3 )
end

function Tutorial5Goal()
	local success = false
	for i=1,#flowers do
		flowers[i].g_match=nil
		if flowers[i].state ~= 'dead' and flowers[i].state ~= 'fruit' and flowers[i].state ~= 'growing' and flowers[i].state ~= 'dying' then
			local n = flowers[i].genes.numpetals:getValueAsAlleleValues()
			if n[1].value >= 5 then
				flowers[i].g_match=true
				success = true
			end
		end
	end

	if success then
		flowers_winning_dude()
	end

	return success
end

function Tutorial6Setup()
	bees = { {} }

	flowers = {}
	MUTATION_ENABLED=false

	colorgene = Gene:new('Color',{1,1,1}, 'count', {3,3,3} )
	heightgene = Gene:new('Height', {1}, 'value', {0} )
	poisongene = Gene:new('Poison',{2}, 'count', {1})
	numpetals = Gene:new('NumPetals',{3}, 'value', {12} )
	attractiveness = Gene:new('Attractiveness', {1}, 'count', {0} )
	genes = { colorgene=colorgene, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	colorgene2 = Gene:new('Color',{1,1,1}, 'count', {0,0,3} )
	heightgene2 = Gene:new('Height', {1}, 'value', {3} )
	poisongene2 = Gene:new('Poison',{2}, 'count', {3})
	genes2 = { colorgene=colorgene2, heightgene=heightgene2, poisongene=poisongene2, numpetals=numpetals, attractiveness=attractiveness }

	colorgene3 = Gene:new('Color',{1,1,1}, 'count', {0,3,0} )
	heightgene3 = Gene:new('Height', {1}, 'value', {3} )
	poisongene3 = Gene:new('Poison',{2}, 'count', {8})
	genes3 = { colorgene=colorgene3, heightgene=heightgene3, poisongene=poisongene3, numpetals=numpetals, attractiveness=attractiveness }

	addflower( 1, 4, nil, nil, nil, nil, genes )
	addflower( 4, 4, nil, nil, nil, nil, genes2 )
	addflower( 7, 4, nil, nil, nil, nil, genes3 )
end

function Tutorial6Goal()
	local success = false
	for i=1,#flowers do
		flowers[i].g_match=nil
		if flowers[i].state ~= 'dead' and flowers[i].state ~= 'fruit' and flowers[i].state ~= 'growing' and flowers[i].state ~= 'dying' then
			local p = flowers[i].genes.poisongene:getValueAsAlleleValues()
			if p[1].count == p[1].maxcount then
				flowers[i].g_match=true
				success = true
			end
		end
	end

	if success then
		flowers_winning_dude()
	end

	return success
end

function Tutorial7Setup()
	bees = { {}, {}, {} }

	flowers = {}
	MUTATION_ENABLED=false

	num_flowers = 5
	for i=1,num_flowers do
		addflower()
	end

	flowers[1].genes.attractiveness = Gene:new('Attractiveness', {2}, 'count', {10} )
	flowers[2].genes.attractiveness = Gene:new('Attractiveness', {2}, 'count', {3} )
	flowers[3].genes.attractiveness = Gene:new('Attractiveness', {2}, 'count', {12} )
	flowers[4].genes.attractiveness = Gene:new('Attractiveness', {2}, 'count', {5} )
	flowers[5].genes.attractiveness = Gene:new('Attractiveness', {2}, 'count', {0} )

end

function Tutorial7Goal()
	local success = false
	local abeecount = 0
	local aflowercount = 0
	for i=1,#bees do
		if bees[i].active then abeecount = abeecount + 1 end
	end

	for i=1,#flowers do
		flowers[i].g_match=nil
	end

	if abeecount > 5 then
		success = true
		for i=1,#flowers do
			flowers[i].g_match=nil
			if flowers[i].state ~= 'dead' then
				flowers[i].g_match = true
				if flowers[i].state == 'fruit' then flowers[i].state = 'growing' end
			end
		end
		flowers_winning_dude()
	end

	return success
end

function Tutorial8Setup()
	bees = { {} }

	colorgene = Gene:new('Color',{1,1,1}, 'count', {3,3,3} )
	heightgene = Gene:new('Height', {1}, 'value', {3} )
	poisongene = Gene:new('Poison',{1}, 'count', {3})
	numpetals = Gene:new('NumPetals',{1}, 'value', {3} )
	attractiveness = Gene:new('Attractiveness', {1}, 'count', {3} )

	genes = { colorgene=colorgene, heightgene=heightgene, poisongene=poisongene, numpetals=numpetals, attractiveness=attractiveness }

	flowers = {}
	MUTATION_ENABLED=true

	addflower( 1, 1, nil, nil, nil, nil, genes )
	addflower( 4, 4, nil, nil, nil, nil, genes )
	addflower( 5, 5, nil, nil, nil, nil, genes )
	addflower( 7, 7, nil, nil, nil, nil, genes )
	flowers[2].state = 'living'
	flowers[3].state = 'living'
end

function Tutorial8Goal()
	local success = false
	for i=1,#flowers do
		flowers[i].g_match=nil
		if flowers[i].state ~= 'dead' and flowers[i].state ~= 'fruit' and flowers[i].state ~= 'growing' and flowers[i].state ~= 'dying' then
			local c = flowers[i].genes.colorgene:getValueAsAlleleValues()
			local h = flowers[i].genes.heightgene:getValueAsAlleleValues()
			local p = flowers[i].genes.poisongene:getValueAsAlleleValues()
			local n = flowers[i].genes.numpetals:getValueAsAlleleValues()
			local a = flowers[i].genes.attractiveness:getValueAsAlleleValues()
			if c[1].value ~= 1 or c[2].value ~= 1 or c[3].value ~= 1 or h[ 1 ].value ~= 1 or p[ 1 ].value ~= 1 or n[ 1 ].value ~= 1 or a[ 1 ].value ~= 1 then
				flowers[i].g_match=true
				success = true
			end
		end
	end

	if success then

		flowers_winning_dude()
	end

	return success
end

function Challenge1Setup()
	bees = { {}, {}, {} }

	flowers = {}
	MUTATION_ENABLED=false

	num_flowers = 5
	for i=1,num_flowers do
		addflower()
	end
end

function Challenge1Goal()
	-- breed three tall white flowers
	local successful = 0
	for i=1,#flowers do
		flowers[i].g_match=nil
		if flowers[i].state ~= 'dead' and flowers[i].state ~= 'fruit' and flowers[i].state ~= 'growing' and flowers[i].state ~= 'dying' then
			local c = flowers[i].genes.colorgene:getValueAsAlleleValues()
			local h = flowers[i].genes.heightgene:getValueAsAlleleValues()
			if h[1].value == h[1].maxvalue then
				if c[1].value == c[1].maxvalue and c[2].value == c[2].maxvalue and c[3].value == c[3].maxvalue then
					successful = successful + 1
					flowers[i].g_match = true
				end
			end
		end
	end

	if successful >= 3 then
		flowers_winning_dude()
		return true
	else
		return false
	end

	return false
end

function TestingModeSetup()
	bees = { {}, {}, {} }

	flowers = {}
	MUTATION_ENABLED=true

	for i=0,gridwidth-1 do
		for j=0,gridheight-1 do
			addflower(i,j)
		end
	end
end

function TestingModeGoal()
	return false
end

levels_data = {
	{caption = 'Tutorial 1 (breeding)',
	 setup = Tutorial1Setup,
	 level_goal_genes = Tutorial1Goal,
	 splash = 'Breed a flower!',
	 timetarget = 'fastest'
	},
	{caption = 'Tutorial 2 (breeding part2)',
	 setup = Tutorial2Setup,
	 level_goal_genes = Tutorial2Goal,
	 splash = 'Breed a flower (harder - but not really!)',
	 timetarget = 'fastest'
	 },
	{caption = 'Tutorial 3 (basic genetics)',
	 setup = Tutorial3Setup,
	 level_goal_genes = Tutorial3Goal,
	 splash = 'Breed a flower that differs from BOTH of its parents. How?',
	 timetarget = 'fastest'
	},
	{caption = 'Tutorial 4 (basic genetics 2)',
	 setup = Tutorial4Setup,
	 level_goal_genes = Tutorial4Goal,
	 splash = "Breed a SHORT flower.  But the parents are all tall?",
	 timetarget = 'fastest'
	},
	{caption = 'Tutorial 5 (basic genetics 3)',
	 setup = Tutorial5Setup,
	 level_goal_genes = Tutorial5Goal,
	 splash = "Breed anything with more than 6 petals! (Hint: Aim for 5/7 or more)",
	 timetarget = 'fastest'
	},
	{caption = 'Tutorial 6 (poison)',
	 setup = Tutorial6Setup,
	 level_goal_genes = Tutorial6Goal,
	 splash = 'Breed something that is 3/3 on the poison scale!',
	 timetarget = 'fastest'
	},
	{caption = 'Tutorial 7 (attractiveness)',
	 setup = Tutorial7Setup,
	 level_goal_genes = Tutorial7Goal,
	 splash = 'Get more than 5 bees!  Some things are more attractive than others, to bees',
	 timetarget = 'fastest'
	},
	{caption = 'Tutorial 8 (mutation)',
	 setup = Tutorial8Setup,
	 level_goal_genes = Tutorial8Goal,
	 splash = 'What is mutation? Where does it come from? Make a new breed!',
	 timetarget = 'fastest'
	},
	{caption = 'Challenge 1',
	 setup = Challenge1Setup,
	 level_goal_genes = Challenge1Goal,
	 splash = 'Make 3 tall white flowers! NO MUTATION!',
	 timetarget = 'fastest'
	},
	{caption = 'Testing Mode',
	 setup = TestingModeSetup,
	 level_goal_genes = TestingModeGoal,
	 splash = 'No goal! Highscores saved when you choose to end! Stay alive!',
	 timetarget = 'longest'
	},
}
